> ## Documentation Index
> Fetch the complete documentation index at: https://docs.neynar.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Mint NFT(s)

> Mints an NFT to one or more recipients on a specified network and contract, using a configured server wallet. Contact us to set up your wallet configuration if you don't have one.

<Info>
  ### Related tutorial: [Minting for Farcaster Users](/docs/mint-for-farcaster-users)
</Info>


## OpenAPI

````yaml post /v2/farcaster/nft/mint/
openapi: 3.0.4
info:
  contact:
    email: team@neynar.com
    name: Neynar
    url: https://neynar.com/
  description: >-
    The Neynar API allows you to interact with the Farcaster protocol among
    other things. See the [Neynar docs](https://docs.neynar.com/reference) for
    more details.
  title: Neynar API
  version: 3.173.0
servers:
  - url: https://api.neynar.com
security:
  - ApiKeyAuth: []
tags:
  - description: Operations related to user
    externalDocs:
      description: More info about user
      url: https://docs.neynar.com/reference/user-operations
    name: User
  - description: Operations related to signer
    externalDocs:
      description: More info about signer
      url: https://docs.neynar.com/reference/signer-operations
    name: Signer
  - description: Operations related to cast
    externalDocs:
      description: More info about cast
      url: https://docs.neynar.com/reference/cast-operations
    name: Cast
  - description: Operations related to feed
    externalDocs:
      description: More info about feed
      url: https://docs.neynar.com/reference/feed-operations
    name: Feed
  - description: Operations related to reaction
    externalDocs:
      description: More info about reaction
      url: https://docs.neynar.com/reference/reaction-operations
    name: Reaction
  - description: Operations related to notifications
    externalDocs:
      description: More info about notifications
      url: https://docs.neynar.com/reference/notifications-operations
    name: Notifications
  - description: Operations related to channels
    externalDocs:
      description: More info about channels
      url: https://docs.neynar.com/reference/channel-operations
    name: Channel
  - description: Operations related to follows
    externalDocs:
      description: More info about follows
      url: https://docs.neynar.com/reference/follows-operations
    name: Follows
  - description: Operations related to storage
    externalDocs:
      description: More info about storage
      url: https://docs.neynar.com/reference/storage-operations
    name: Storage
  - description: Operations related to mini apps
    name: Frame
  - description: Operations for building AI agents
    name: Agents
  - description: Operations related to fname
    name: fname
  - description: Operations related to a webhook
    name: Webhook
  - description: >-
      Securely communicate and perform actions on behalf of users across
      different apps
    externalDocs:
      description: More info about farcaster actions
      url: https://docs.neynar.com/docs/farcaster-actions-spec
    name: Action
  - description: Operations related to a subscriptions
    name: Subscribers
  - description: Operations related to a mute
    name: Mute
  - description: Operations related to a block
    name: Block
  - description: Operations related to a ban
    name: Ban
  - description: Operations related to onchain data
    name: Onchain
  - description: Operations related to login
    name: Login
  - description: Operations related to retrieving metrics
    name: Metrics
  - description: Operations related to mini app host notifications
    externalDocs:
      description: More info about mini app host notifications
      url: https://docs.neynar.com/docs/app-host-notifications
    name: App Host
paths:
  /v2/farcaster/nft/mint/:
    post:
      tags:
        - Onchain
      summary: Mint NFT(s)
      description: >-
        Mints an NFT to one or more recipients on a specified network and
        contract, using a configured server wallet. Contact us to set up your
        wallet configuration if you don't have one.
      operationId: mint-nft
      parameters:
        - $ref: '#/components/parameters/WalletIdHeader'
      requestBody:
        content:
          application/json:
            schema:
              description: Request body for NFT minting operation.
              properties:
                async:
                  description: If true, returns immediately after sending the transaction.
                  example: false
                  type: boolean
                contract_address:
                  description: Ethereum address
                  example: '0x5a927ac639636e534b678e81768ca19e2c6280b7'
                  pattern: ^0x[a-fA-F0-9]{40}$
                  title: EthAddress
                  type: string
                network:
                  description: Network to mint on.
                  enum:
                    - base
                    - optimism
                    - base-sepolia
                  example: base
                  type: string
                recipients:
                  description: List of recipients to mint to (1-200 recipients allowed).
                  items:
                    anyOf:
                      - properties:
                          address:
                            description: Ethereum address
                            example: '0x5a927ac639636e534b678e81768ca19e2c6280b7'
                            pattern: ^0x[a-fA-F0-9]{40}$
                            title: EthAddress
                            type: string
                          fid:
                            not: {}
                          quantity:
                            default: 1
                            description: >-
                              Quantity to mint (must be at least 1). Defaults to
                              1.
                            example: 1
                            minimum: 1
                            type: integer
                        required:
                          - address
                        type: object
                      - properties:
                          address:
                            not: {}
                          fid:
                            description: >-
                              The unique identifier of a farcaster user or app
                              (unsigned integer)
                            example: 3
                            format: int32
                            minimum: 0
                            title: Fid
                            type: integer
                          quantity:
                            default: 1
                            description: >-
                              Quantity to mint (must be at least 1). Defaults to
                              1.
                            example: 1
                            minimum: 1
                            type: integer
                        required:
                          - fid
                        type: object
                    description: >-
                      NFT mint recipient. Exactly one of "address" or "fid" must
                      be set.
                  maxItems: 200
                  minItems: 1
                  type: array
              required:
                - network
                - contract_address
                - recipients
              type: object
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                description: Response for NFT minting operation.
                properties:
                  transactions:
                    description: Array of per-recipient mint results (success or error).
                    items:
                      oneOf:
                        - description: Successful mint transaction.
                          properties:
                            receipt:
                              description: Transaction receipt (if async is false).
                              nullable: true
                              properties:
                                block_number:
                                  type: string
                                gas_used:
                                  type: string
                                status:
                                  type: string
                              required:
                                - status
                                - gas_used
                                - block_number
                              type: object
                            recipient:
                              description: Resolved mint recipient.
                              properties:
                                address:
                                  $ref: '#/components/schemas/EthAddress'
                                fid:
                                  $ref: '#/components/schemas/Fid'
                                quantity:
                                  minimum: 1
                                  type: integer
                                tokens:
                                  description: >-
                                    Minted token IDs parsed from Transfer events
                                    (sync mode only).
                                  items:
                                    properties:
                                      token_id:
                                        type: string
                                    required:
                                      - token_id
                                    type: object
                                  type: array
                              required:
                                - address
                                - quantity
                              type: object
                            transaction_hash:
                              $ref: '#/components/schemas/PrefixedHexString'
                          required:
                            - recipient
                            - transaction_hash
                          type: object
                        - description: Failed mint for a single recipient.
                          properties:
                            error:
                              description: Error message for this recipient.
                              example: No supported mint project detected
                              type: string
                            recipient:
                              description: Mint recipient that failed.
                              properties:
                                address:
                                  $ref: '#/components/schemas/EthAddress'
                                fid:
                                  $ref: '#/components/schemas/Fid'
                                quantity:
                                  minimum: 1
                                  type: integer
                              required:
                                - quantity
                              type: object
                          required:
                            - recipient
                            - error
                          type: object
                    type: array
                required:
                  - transactions
                type: object
          description: Success
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ZodError'
          description: Bad Request
        '401':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorRes'
          description: Unauthorized
        '402':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorRes'
          description: Payment Required
        '404':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorRes'
          description: Resource not found
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorRes'
          description: Server Error
      externalDocs:
        url: https://docs.neynar.com/reference/mint-nft
components:
  parameters:
    WalletIdHeader:
      description: Wallet ID to use for transactions
      in: header
      name: x-wallet-id
      required: true
      schema:
        type: string
      x-is-global-header: true
  schemas:
    EthAddress:
      description: Ethereum address
      example: '0x5a927ac639636e534b678e81768ca19e2c6280b7'
      pattern: ^0x[a-fA-F0-9]{40}$
      title: EthAddress
      type: string
    Fid:
      description: The unique identifier of a farcaster user or app (unsigned integer)
      example: 3
      format: int32
      minimum: 0
      title: Fid
      type: integer
    PrefixedHexString:
      description: Hexadecimal number expressed as string with '0x' prefix
      pattern: ^0x[a-fA-F0-9]+$
      title: PrefixedHexString
      type: string
    ZodError:
      properties:
        code:
          example: InvalidField
          type: string
        errors:
          items:
            properties:
              code:
                type: string
              expected:
                type: string
              message:
                type: string
              path:
                items:
                  type: string
                type: array
              received:
                type: string
            required:
              - code
              - expected
              - received
              - path
              - message
            type: object
          type: array
        message:
          example: Invalid query parameters
          type: string
      required:
        - message
        - code
        - errors
      title: ZodError
      type: object
    ErrorRes:
      description: Details for the error response
      properties:
        code:
          type: string
        message:
          type: string
        property:
          type: string
        status:
          format: int32
          type: integer
      required:
        - message
      title: ErrorRes
      type: object
  securitySchemes:
    ApiKeyAuth:
      description: API key to authorize requests
      in: header
      name: x-api-key
      type: apiKey
      x-default: NEYNAR_API_DOCS

````